import * as React from 'react';
import CodeMirror from 'codemirror';
import './languages/log';
import './languages/simpleLog';
import 'codemirror/lib/codemirror.css';
import 'codemirror/addon/lint/lint.css';
import 'codemirror/addon/scroll/simplescrollbars.css';
import './style.scss';
declare type EditorEventCallback = (prevValue: string, nextValue: string, editorDoc: CodeMirror.Doc) => void;
interface CodeMirrorEditorProps {
    value: string;
    /**
     * The cursor position
     */
    cursor?: CodeMirror.Position;
    /**
     * Whether sync the editor value when props value changed
     */
    sync?: boolean;
    /**
     * Editor option
     */
    options?: CodeMirror.EditorConfiguration;
    /**
     * Always show cursor in the end.
     * This option be used when streaming output, such as typing logs.
     */
    cursorAlwaysInEnd?: boolean;
    editorRef?: (inst: CodeMirror.Editor) => void;
    cursorActivity?: EditorEventCallback;
    onChange?: EditorEventCallback;
    onFocus?: EditorEventCallback;
    focusOut?: EditorEventCallback;
    className?: string;
    style?: React.CSSProperties;
}
declare class CodeMirrorEditor extends React.Component<CodeMirrorEditorProps, any> {
    private _editorRef;
    private _codeMirrorInstance;
    componentDidMount(): void;
    static fromTextArea(ele: HTMLTextAreaElement, options: CodeMirror.EditorConfiguration): any;
    UNSAFE_componentWillReceiveProps(nextProps: any): void;
    renderTextMark(): void;
    render(): JSX.Element;
}
export default CodeMirrorEditor;
